Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/HiveDataContext.designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/HiveDataContext.designer.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/HiveDataContext.designer.cs	(revision 6006)
@@ -1424,4 +1424,6 @@
 		private global::HeuristicLab.Services.Hive.Common.DataTransfer.Command? _Command;
 		
+		private System.Guid _HiveExperimentId;
+		
 		private EntitySet<AssignedResource> _AssignedResources;
 		
@@ -1435,4 +1437,6 @@
 		
 		private EntityRef<Job> _Job1;
+		
+		private EntityRef<HiveExperiment> _HiveExperiment;
 		
     #region Extensibility Method Definitions
@@ -1462,4 +1466,6 @@
     partial void OnCommandChanging(global::HeuristicLab.Services.Hive.Common.DataTransfer.Command? value);
     partial void OnCommandChanged();
+    partial void OnHiveExperimentIdChanging(System.Guid value);
+    partial void OnHiveExperimentIdChanged();
     #endregion
 		
@@ -1472,4 +1478,5 @@
 			this._StateLogs = new EntitySet<StateLog>(new Action<StateLog>(this.attach_StateLogs), new Action<StateLog>(this.detach_StateLogs));
 			this._Job1 = default(EntityRef<Job>);
+			this._HiveExperiment = default(EntityRef<HiveExperiment>);
 			OnCreated();
 		}
@@ -1699,4 +1706,28 @@
 		}
 		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_HiveExperimentId", DbType="UniqueIdentifier NOT NULL")]
+		public System.Guid HiveExperimentId
+		{
+			get
+			{
+				return this._HiveExperimentId;
+			}
+			set
+			{
+				if ((this._HiveExperimentId != value))
+				{
+					if (this._HiveExperiment.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnHiveExperimentIdChanging(value);
+					this.SendPropertyChanging();
+					this._HiveExperimentId = value;
+					this.SendPropertyChanged("HiveExperimentId");
+					this.OnHiveExperimentIdChanged();
+				}
+			}
+		}
+		
 		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Job_AssignedResource", Storage="_AssignedResources", ThisKey="JobId", OtherKey="JobId")]
 		public EntitySet<AssignedResource> AssignedResources
@@ -1810,4 +1841,38 @@
 					}
 					this.SendPropertyChanged("ParentJob");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="HiveExperiment_Job", Storage="_HiveExperiment", ThisKey="HiveExperimentId", OtherKey="HiveExperimentId", IsForeignKey=true)]
+		public HiveExperiment HiveExperiment
+		{
+			get
+			{
+				return this._HiveExperiment.Entity;
+			}
+			set
+			{
+				HiveExperiment previousValue = this._HiveExperiment.Entity;
+				if (((previousValue != value) 
+							|| (this._HiveExperiment.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._HiveExperiment.Entity = null;
+						previousValue.Jobs.Remove(this);
+					}
+					this._HiveExperiment.Entity = value;
+					if ((value != null))
+					{
+						value.Jobs.Add(this);
+						this._HiveExperimentId = value.HiveExperimentId;
+					}
+					else
+					{
+						this._HiveExperimentId = default(System.Guid);
+					}
+					this.SendPropertyChanged("HiveExperiment");
 				}
 			}
@@ -2146,6 +2211,4 @@
 		private System.Guid _UserId;
 		
-		private System.Guid _RootJobId;
-		
 		private System.DateTime _DateCreated;
 		
@@ -2156,5 +2219,5 @@
 		private EntitySet<HiveExperimentPermission> _HiveExperimentPermissions;
 		
-		private EntityRef<Job> _Job;
+		private EntitySet<Job> _Jobs;
 		
     #region Extensibility Method Definitions
@@ -2172,6 +2235,4 @@
     partial void OnOwnerUserIdChanging(System.Guid value);
     partial void OnOwnerUserIdChanged();
-    partial void OnRootJobIdChanging(System.Guid value);
-    partial void OnRootJobIdChanged();
     partial void OnDateCreatedChanging(System.DateTime value);
     partial void OnDateCreatedChanged();
@@ -2185,5 +2246,5 @@
 		{
 			this._HiveExperimentPermissions = new EntitySet<HiveExperimentPermission>(new Action<HiveExperimentPermission>(this.attach_HiveExperimentPermissions), new Action<HiveExperimentPermission>(this.detach_HiveExperimentPermissions));
-			this._Job = default(EntityRef<Job>);
+			this._Jobs = new EntitySet<Job>(new Action<Job>(this.attach_Jobs), new Action<Job>(this.detach_Jobs));
 			OnCreated();
 		}
@@ -2289,28 +2350,4 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RootJobId", DbType="UniqueIdentifier")]
-		public System.Guid RootJobId
-		{
-			get
-			{
-				return this._RootJobId;
-			}
-			set
-			{
-				if ((this._RootJobId != value))
-				{
-					if (this._Job.HasLoadedOrAssignedValue)
-					{
-						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-					}
-					this.OnRootJobIdChanging(value);
-					this.SendPropertyChanging();
-					this._RootJobId = value;
-					this.SendPropertyChanged("RootJobId");
-					this.OnRootJobIdChanged();
-				}
-			}
-		}
-		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DateCreated", DbType="DateTime")]
 		public System.DateTime DateCreated
@@ -2386,19 +2423,14 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Job_HiveExperiment", Storage="_Job", ThisKey="RootJobId", OtherKey="JobId", IsForeignKey=true, DeleteRule="CASCADE")]
-		public Job RootJob
-		{
-			get
-			{
-				return this._Job.Entity;
-			}
-			set
-			{
-				if ((this._Job.Entity != value))
-				{
-					this.SendPropertyChanging();
-					this._Job.Entity = value;
-					this.SendPropertyChanged("RootJob");
-				}
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="HiveExperiment_Job", Storage="_Jobs", ThisKey="HiveExperimentId", OtherKey="HiveExperimentId")]
+		public EntitySet<Job> Jobs
+		{
+			get
+			{
+				return this._Jobs;
+			}
+			set
+			{
+				this._Jobs.Assign(value);
 			}
 		}
@@ -2431,4 +2463,16 @@
 		
 		private void detach_HiveExperimentPermissions(HiveExperimentPermission entity)
+		{
+			this.SendPropertyChanging();
+			entity.HiveExperiment = null;
+		}
+		
+		private void attach_Jobs(Job entity)
+		{
+			this.SendPropertyChanging();
+			entity.HiveExperiment = this;
+		}
+		
+		private void detach_Jobs(Job entity)
 		{
 			this.SendPropertyChanging();
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/prepareHiveDatabase.sql
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/prepareHiveDatabase.sql	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.4/Tools/prepareHiveDatabase.sql	(revision 6006)
@@ -55,4 +55,11 @@
 GO
 
+--ALTER TABLE [dbo].[Job]  DROP  CONSTRAINT [HiveExperiment_Job]
+--ALTER TABLE [dbo].[Job]  WITH CHECK ADD CONSTRAINT [HiveExperiment_Job] FOREIGN KEY([HiveExperimentId])
+--REFERENCES [dbo].[HiveExperiment] ([HiveExperimentId])
+--ON UPDATE CASCADE
+--ON DELETE CASCADE
+--GO
+
 ALTER TABLE dbo.Plugin ALTER COLUMN PluginId ADD ROWGUIDCOL;
 ALTER TABLE dbo.Plugin WITH NOCHECK ADD CONSTRAINT [DF_Plugin_PluginId] DEFAULT (newid()) FOR PluginId;
@@ -107,11 +114,13 @@
 -- =============================================
 -- Author:		cneumuel
--- Create date: 11.11.2010
--- Description:	Deletes the root-job of the experiment when experiment is deleted
+-- Create date: 11.04.2011
+-- Description:	Deletes all associated jobs. This cannot be done with cascading delete, 
+--              because the job table defines a INSTEAD OF DELETE trigger itself, which
+--              is not compatible with cascading deletes.
 -- =============================================
-CREATE TRIGGER [dbo].[tr_HiveExperimentDeleteCascade] ON [dbo].[HiveExperiment] FOR DELETE AS 
-SET NOCOUNT ON
-DELETE Job FROM deleted, Job WHERE Job.JobId = deleted.RootJobId
-GO
+ALTER TRIGGER [dbo].[tr_HiveExperimentDeleteCascade] ON [dbo].[HiveExperiment] INSTEAD OF DELETE AS 
+BEGIN
+	DELETE Job FROM Job WHERE Job.HiveExperimentId = HiveExperimentId
+END
 
 SET ANSI_NULLS ON
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/DaoTests.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/DaoTests.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/DaoTests.cs	(revision 6006)
@@ -15,5 +15,4 @@
     [ClassInitialize]
     public static void MyClassInitialize(TestContext testContext) {
-      PluginLoader.pluginAssemblies.Any();
       ServiceLocator.Instance = new MockServiceLocator(ServiceLocator.Instance);
     }
@@ -26,4 +25,11 @@
     public void TestJobDao() {
       IHiveDao dao = ServiceLocator.Instance.HiveDao;
+
+      DT.HiveExperiment he = new DT.HiveExperiment();
+      he.DateCreated = DateTime.Now;
+      he.Name = "TestExperiment";
+      he.OwnerUserId = Guid.NewGuid();
+      he.ResourceNames = "HEAL";
+      he.Id = dao.AddHiveExperiment(he);
 
       DT.Job job1 = new DT.Job();
@@ -31,4 +37,5 @@
       job1.StateLog.Add(new DT.StateLog { State = JobState.Offline, DateTime = DateTime.Now });
       job1.Command = Command.Pause;
+      job1.HiveExperimentId = he.Id;
 
       DT.JobData jobData1 = new DT.JobData();
@@ -66,4 +73,5 @@
       Assert.AreEqual(job1.StateLog.Count, job1loaded.StateLog.Count);
       Assert.AreEqual(job1.Command, job1loaded.Command);
+      Assert.AreEqual(job1.HiveExperimentId, job1loaded.HiveExperimentId);
       Assert.IsTrue(Math.Abs((job1loaded.LastJobDataUpdate - jobData1.LastUpdate).TotalSeconds) < 1);
       for (int i = 0; i < job1.StateLog.Count; i++) {
@@ -99,9 +107,10 @@
       Assert.IsTrue(Math.Abs((jobData1.LastUpdate - jobData1Loaded.LastUpdate).TotalSeconds) < 1);
       Assert.IsTrue(jobData1.Data.SequenceEqual(jobData1Loaded.Data));
-      
-      dao.DeleteJob(job1.Id);
+
+      dao.DeleteHiveExperiment(he.Id);
 
       Assert.AreEqual(null, dao.GetJob(job1.Id));
       Assert.AreEqual(null, dao.GetJobData(job1.Id));
+      Assert.AreEqual(null, dao.GetHiveExperiment(he.Id));
     }
 
@@ -184,17 +193,15 @@
 
       DT.HiveExperiment he = new DT.HiveExperiment();
-
-      DT.Job job = new DT.Job();
-      job.State = JobState.Offline;
-      job.StateLog.Add(new DT.StateLog { State = JobState.Offline, DateTime = DateTime.Now });
-      job.Id = dao.AddJob(job);
-
-      he.RootJobId = job.Id;
       he.DateCreated = DateTime.Now;
       he.Name = "TestExperiment";
       he.OwnerUserId = Guid.NewGuid();
       he.ResourceNames = "HEAL";
-
       he.Id = dao.AddHiveExperiment(he);
+
+      DT.Job job = new DT.Job();
+      job.State = JobState.Offline;
+      job.StateLog.Add(new DT.StateLog { State = JobState.Offline, DateTime = DateTime.Now });
+      job.HiveExperimentId = he.Id;
+      job.Id = dao.AddJob(job);
 
       DT.HiveExperimentPermission perm = new DT.HiveExperimentPermission();
@@ -209,11 +216,11 @@
       Assert.AreEqual(he.Name, heLoaded.Name);
       Assert.AreEqual(he.ResourceNames, heLoaded.ResourceNames);
-      Assert.AreEqual(he.RootJobId, heLoaded.RootJobId);
       //Assert.AreEqual(he.LastAccessed, heLoaded.LastAccessed);
       //Assert.AreEqual(he.DateCreated, heLoaded.DateCreated);
 
-      DT.Job jobLoaded = dao.GetJob(he.RootJobId);
+      DT.Job jobLoaded = dao.GetJob(job.Id);
       Assert.AreEqual(job.Id, jobLoaded.Id);
       Assert.AreEqual(job.State, jobLoaded.State);
+      Assert.AreEqual(job.HiveExperimentId, jobLoaded.HiveExperimentId);
 
       DT.HiveExperimentPermission permLoaded = dao.GetHiveExperimentPermission(he.Id, perm.GrantedUserId);
@@ -225,5 +232,5 @@
       dao.DeleteHiveExperiment(he.Id);
       Assert.AreEqual(null, dao.GetHiveExperiment(he.Id));
-      Assert.AreEqual(null, dao.GetJob(he.RootJobId));
+      Assert.AreEqual(null, dao.GetJob(job.Id));
       Assert.AreEqual(null, dao.GetHiveExperimentPermission(perm.HiveExperimentId, perm.GrantedUserId));
 
